%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global service neutron

%define cleanup_orphan_rootwrap_daemons() \
for pid in $(ps -f --ppid 1 | awk '/.*neutron-rootwrap-daemon/ { print $2 }'); do \
   kill $(ps --ppid $pid -o pid=) \
done \
%nil


Name:           openstack-%{service}
Version:        9.4.1
Release:        56%{?dist}
Epoch:          1
Summary:        OpenStack Networking Service

License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0:        https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz
Source1:        %{service}.logrotate
Source2:        %{service}-sudoers
Source10:       neutron-server.service
Source11:       neutron-linuxbridge-agent.service
Source12:       neutron-openvswitch-agent.service
Source15:       neutron-dhcp-agent.service
Source16:       neutron-l3-agent.service
Source17:       neutron-metadata-agent.service
Source18:       neutron-ovs-cleanup.service
Source19:       neutron-macvtap-agent.service
Source20:       neutron-metering-agent.service
Source21:       neutron-sriov-nic-agent.service
Source22:       neutron-netns-cleanup.service
Source23:       neutron-netns-cleanup.init
Source24:       neutron-ovs-cleanup.init
Source25:       NetnsCleanup.ocf_ra
Source26:       OVSCleanup.ocf_ra
Source27:       NeutronScale.ocf_ra
Source29:       neutron-rpc-server.service

Source30:       %{service}-dist.conf
Source31:       conf.README
Source32:       neutron-linuxbridge-cleanup.service
Source33:       neutron-enable-bridge-firewall.sh
Source34:       neutron-l2-agent-sysctl.conf
# We use the legacy service to load modules because it allows to gracefully
# ignore a missing kernel module (f.e. br_netfilter on earlier kernels). It's
# essentially because .modules files are shell scripts.
Source35:       neutron-l2-agent.modules

#
# patches_ignore=DROP-IN-RPM
# patches_base=9.4.1
#
Patch0001: 0001-Replace-tabs-back-to-spaces-in-setup.cfg.patch
Patch0002: 0002-Switch-ns-metadata-proxy-to-haproxy.patch
Patch0003: 0003-Fix-test_keepalived_ipv6_support-for-Keepalived-v1.2.patch
Patch0004: 0004-Make-use-of-w-argument-for-iptables-calls.patch
Patch0005: 0005-Tempest-Adopt-keystone-api-v3-for-tests.patch
Patch0006: 0006-Notify-port_update-to-agent-for-status-change.patch
Patch0007: 0007-iptables-don-t-log-lock-error-if-we-haven-t-passed-w.patch
Patch0008: 0008-Trim-rally-scenario-sizes.patch
Patch0009: 0009-Reduce-rally-sub-port-count.patch
Patch0010: 0010-Enforce-ethertype-with-IPv6-integer-protocols.patch
Patch0011: 0011-Stop-logging-versions-on-every-agent-update.patch
Patch0012: 0012-Fixes-import_modules_recursively-for-Windows.patch
Patch0013: 0013-Linuxbridge-agent-detect-existing-IP-on-bridge.patch
Patch0014: 0014-Prioritize-tox-environment-executables-for-fullstack.patch
Patch0015: 0015-Match-load_rc_for_rally-logic-to-load_rc_hook.patch
Patch0016: 0016-DHCP-provisioning-block-only-on-port-addr-update.patch
Patch0017: 0017-test_ha_router-wait-until-two-agents-are-scheduled.patch
Patch0018: 0018-Fix-missing-super-s-skip_checks.patch
Patch0019: 0019-rally-switch-to-new-format-for-context-name.patch
Patch0020: 0020-Skip-setup_port_filters-for-skipped_devices.patch
Patch0021: 0021-Change-OVS-agent-to-update-skipped-port-status-to-DO.patch
Patch0022: 0022-Fix-bad-l3-agent-backport-to-stable-newton.patch
Patch0023: 0023-Tempest-Fixing-L3-agent-hosting-router-for-DVR-setup.patch
Patch0024: 0024-Move-check_ha_state_for_router-into-notification-cod.patch
Patch0025: 0025-Don-t-wait-on-TRY_AGAIN-when-calling-commit_block.patch
Patch0026: 0026-Call-update_all_ha_network_port_statuses-on-agent-st.patch
Patch0027: 0027-functional-tests-Make-addresses-for-tunneling-unique.patch
Patch0028: 0028-ovs-lib-Pass-string-as-udp-port-to-ovsdb.patch
Patch0029: 0029-l3_ha-only-pass-host-into-update_port-when-updating-.patch
Patch0030: 0030-Pass-parameters-when-create-eventlet.wsgi-server.patch
Patch0031: 0031-More-efficiently-clean-up-OVS-ports.patch
Patch0032: 0032-Spawn-stop-metadata-proxies-upon-adding-deleting-rou.patch
Patch0033: 0033-DVR-verify-subnet-has-gateway_ip-before-installing-I.patch
Patch0034: 0034-Process-conntrack-updates-in-worker-threads.patch
Patch0035: 0035-Remove-race-and-simplify-conntrack-state-management.patch
Patch0036: 0036-Using-a-new-security-group-in-scenario-tests.patch
Patch0037: 0037-Checking-functionality-of-DVR.patch
Patch0038: 0038-Add-a-tempest-scenario-for-floating-ip.patch
Patch0039: 0039-tempest-Use-kwargs-for-create_server.patch
Patch0040: 0040-Write-vrrp_script-before-re-starting-keepalived.patch
Patch0041: 0041-adds-support-for-vhost-user-reconnect.patch
Patch0042: 0042-RBAC-Fix-setting-network-as-not-shared.patch
Patch0043: 0043-ml2-fix-update_device_up-to-send-lm-events-with-linu.patch
Patch0044: 0044-Fix-parallel-deletion-of-subnets.patch
Patch0045: 0045-Adding-fix-to-failing-scenario-tests-in-CI.patch
Patch0046: 0046-Monitor-phys_bridges-to-reconfigured-it-if-created-a.patch
Patch0047: 0047-Don-t-delete-flows-on-ports-which-were-on-dead-vlan-.patch
Patch0048: 0048-Avoid-agents-adding-ports-as-trunk-by-default.patch
Patch0049: 0049-Improve-DbListCommand-operation-from-O-n-2-to-O-n.patch
Patch0050: 0050-Override-ovsdb_timeout-default-value-in-ovs_cleanup-.patch
Patch0051: 0051-Retry-dhcp_release-on-failures.patch
Patch0052: 0052-Disable-IPv6-forwarding-by-default-on-HA-routers.patch
Patch0053: 0053-OVS-Add-mac-table-size-to-be-set-on-each-ovs-bridge.patch
Patch0054: 0054-DVR-Inter-Tenant-Traffic-between-networks-not-possib.patch
Patch0055: 0055-Disallow-router-interface-out-of-subnet-IP-range.patch
Patch0056: 0056-Remove-fdb-entries-for-ha-router-interfaces-when-goi.patch
Patch0057: 0057-ovsdb-monitor-do-not-die-on-ovsdb-client-stderr-outp.patch
Patch0058: 0058-Revert-DVR-Inter-Tenant-Traffic-between-networks-not.patch
Patch0059: 0059-Reduce-rpc-calls-in-SR-IOV-agent.patch
Patch0060: 0060-Fix-corner-case-in-failure-assigning-MAC-to-SR-IOV-N.patch
Patch0061: 0061-Fix-connection-between-2-dvr-routers.patch
Patch0062: 0062-DVR-Server-side-patch-to-schedule-an-unbound-port-wi.patch
Patch0063: 0063-Do-not-delete-trunk-bridges-if-service-port-attached.patch
Patch0064: 0064-Add-connectivity-test-via-2-routers-and-tenant-netwo.patch
Patch0065: 0065-Fix-connectivity-via-2-routers-test.patch
Patch0066: 0066-Fix-notification-about-arp-entries-for-dvr-routers.patch
Patch0067: 0067-Fix-update-of-ports-cache-in-router_info-class.patch
Patch0068: 0068-Skip-IPv6-sysctl-calls-when-IPv6-is-disabled.patch
Patch0069: 0069-Wait-to-ipv6-forwarding-be-really-changed-by-L3-agen.patch
Patch0070: 0070-DVR-Multiple-csnat-ports-created-when-RouterPort-tab.patch
Patch0071: 0071-Run-revision-bump-operations-en-masse.patch
Patch0072: 0072-Enable-ipv6_forwarding-in-HA-router-s-namespace.patch
Patch0073: 0073-Do-not-raise-an-error-deleting-neighbour-entry.patch
Patch0074: 0074-When-converting-sg-rules-to-iptables-do-not-emit-dpo.patch
Patch0075: 0075-Fix-callers-of-get_devices_with_ip-to-pass-addresses.patch
Patch0076: 0076-Add-permanent-ARP-entries-for-DVR-fip-qrouter-veth-p.patch
Patch0077: 0077-Choose-random-value-for-HA-routes-vr_id.patch
Patch0078: 0078-Add-missing-policy-actions-to-policy.json-file.patch
Patch0079: 0079-Fix-creating-policy-rules-from-subattributes.patch
Patch0080: 0080-Fix-handling-of-network-shared-field-in-policy-modul.patch
Patch0081: 0081-Enable-all-IPv6-forwarding-knob-correctly.patch
Patch0082: 0082-dvr-Don-t-raise-KeyError-in-_get_floatingips_bound_t.patch
Patch0083: 0083-Do-not-release-DHCP-lease-when-no-client-ID-is-set-o.patch
Patch0084: 0084-DVR-FIP-gateway-port-is-tagged-as-DEAD-port-by-OVS-w.patch
Patch0085: 0085-Change-VF-status-from-enable-to-auto.patch
Patch0086: 0086-Reduce-IP-address-collision-during-port-creating.patch
Patch0087: 0087-Delay-floating-IP-assignation-in-DVR-router-during-m.patch
Patch0088: 0088-Reduce-timeout-and-number-of-arping-attempts.patch
Patch0089: 0089-Limit-max-ports-per-rpc-for-dhcp_ready_on_ports.patch
Patch0090: 0090-Switch-to-use-cast-method-in-dhcp_ready_on_ports-met.patch
Patch0091: 0091-Fixes-overwrite-of-pre-existing-other_config.patch
Patch0092: 0092-Use-threading-for-pinging-the-floating-IP.patch
Patch0093: 0093-Remove-dhcp_extra_opt-value-after-first-newline-char.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python-babel
BuildRequires:  python-d2to1
BuildRequires:  python-keystoneauth1 >= 2.10.0
BuildRequires:  python-keystonemiddleware
BuildRequires:  python-neutron-lib
BuildRequires:  python-novaclient
BuildRequires:  python-oslo-cache
BuildRequires:  python-oslo-concurrency
BuildRequires:  python-oslo-config
BuildRequires:  python-oslo-db
BuildRequires:  python-oslo-log
BuildRequires:  python-oslo-messaging
BuildRequires:  python-oslo-policy
BuildRequires:  python-oslo-rootwrap
BuildRequires:  python-oslo-service
BuildRequires:  python-oslo-versionedobjects
BuildRequires:  python-osprofiler >= 1.3.0
BuildRequires:  python-pbr >= 1.6
BuildRequires:  python-pecan
BuildRequires:  python-setuptools
BuildRequires:  systemd-units

Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}

# dnsmasq is not a hard requirement, but is currently the only option
# when neutron-dhcp-agent is deployed.
Requires:       dnsmasq >= 2.76
Requires:       dnsmasq-utils >= 2.76

# radvd is not a hard requirement, but is currently the only option
# for IPv6 deployments.
Requires:       radvd

# dibbler is not a hard requirement, but is currently the default option
# for IPv6 prefix delegation.
Requires:       dibbler-client

# conntrack is not a hard requirement, but is currently used by L3 agent
# to immediately drop connections after a floating IP is disassociated
Requires:       conntrack-tools

# keepalived is not a hard requirement, but is currently used by DVR L3
# agent
Requires:       keepalived

# haproxy implements metadata proxy process
Requires:       haproxy >= 1.5.0

# Those are not hard requirements, ipset is used by ipset-cleanup in the subpackage,
# and iptables is used by the l3-agent which currently is not in a separate package.
Requires:       ipset
Requires:       iptables

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

Obsoletes:      openstack-%{service}-dev-server

%description
Neutron is a virtual network service for Openstack. Just like
OpenStack Nova provides an API to dynamically request and configure
virtual servers, Neutron provides an API to dynamically request and
configure virtual networks. These networks connect "interfaces" from
other OpenStack services (e.g., virtual NICs from Nova VMs). The
Neutron API supports extensions to provide advanced network
capabilities (e.g., QoS, ACLs, network monitoring, etc.)


%package -n python-%{service}
Summary:        Neutron Python libraries
Requires:       python-alembic >= 0.8.4
Requires:       python-debtcollector >= 1.2.0
Requires:       python-designateclient >= 1.5.0
Requires:       python-eventlet >= 0.17.4
Requires:       python-greenlet >= 0.3.2
Requires:       python-httplib2 >= 0.7.5
Requires:       python-jinja2 >= 2.6
Requires:       python-keystoneauth1 >= 2.10.0
Requires:       python-keystoneclient >= 1.6.0
Requires:       python-keystonemiddleware >= 4.0.0
Requires:       python-netaddr >= 0.7.12
Requires:       python-netifaces >= 0.10.4
Requires:       python-neutronclient >= 2.6.0
Requires:       python-neutron-lib >= 0.4.0
Requires:       python-novaclient >= 2.29.0
Requires:       python-oslo-cache >= 1.5.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-config >= 2:3.14.0
Requires:       python-oslo-context >= 2.9.0
Requires:       python-oslo-db >= 4.10.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 1.14.0
Requires:       python-oslo-messaging >= 5.2.0
Requires:       python-oslo-middleware >= 3.0.0
Requires:       python-oslo-policy >= 1.9.0
Requires:       python-oslo-reports >= 0.6.0
Requires:       python-oslo-rootwrap >= 5.0.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-service >= 1.0.0
Requires:       python-oslo-utils >= 3.5.0
Requires:       python-oslo-versionedobjects >= 1.13.0
Requires:       python-osprofiler >= 1.4.0
Requires:       python-paste
Requires:       python-paste-deploy >= 1.5.0
Requires:       python-pecan >= 1.0.0
Requires:       python-pbr >= 1.6
Requires:       python-requests >= 2.5.2
Requires:       python-retrying >= 1.2.3
Requires:       python-routes >= 1.12.3
Requires:       python-ryu >= 3.30
Requires:       python-six >= 1.9.0
Requires:       python-sqlalchemy >= 1.0.10
Requires:       python-stevedore >= 1.16.0
Requires:       python-webob >= 1.2.3



%description -n python-%{service}
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron Python library.


%package -n python-%{service}-tests
Summary:        Neutron tests
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       python-ddt >= 1.0.1
Requires:       python-fixtures >= 3.0.0
Requires:       python-mock >= 2.0
Requires:       python-subunit >= 0.0.18
Requires:       python-testrepository >= 0.0.18
Requires:       python-testtools >= 1.4.0
Requires:       python-testresources >= 0.2.4
Requires:       python-testscenarios >= 0.4
Requires:       python-oslotest >= 1.10.0
Requires:       python-os-testr >= 0.7.0
Requires:       python-PyMySQL >= 0.6.2
Requires:       python-tempest >= 12.1.0
Requires:       python-webtest

# pstree is used during functional testing to ensure our internal
# libraries managing processes work correctly.
Requires:       psmisc

# nfs-utils is needed because it creates user with uid 65534 which
# is required by neutron functional tests.
Requires:       nfs-utils



%description -n python-%{service}-tests
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains Neutron test files.


%package common
Summary:        Neutron common files
Requires(pre): shadow-utils
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       sudo


%description common
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains Neutron common files.


%package linuxbridge
Summary:        Neutron Linuxbridge agent
Requires:       bridge-utils
Requires:       ebtables
Requires:       ipset
Requires:       iptables
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description linuxbridge
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron agent that implements virtual
networks using VLAN or VXLAN using Linuxbridge technology.


%package macvtap-agent
Summary:        Neutron macvtap agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description macvtap-agent
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron agent that implements
macvtap attachments for libvirt qemu/kvm instances.


%package ml2
Summary:        Neutron ML2 plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# needed for brocade and cisco drivers
Requires:       python-ncclient


%description ml2
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains a Neutron plugin that allows the use of drivers
to support separately extensible sets of network types and the mechanisms
for accessing those types.


%package openvswitch
Summary:        Neutron openvswitch plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# We require openvswitch when using vsctl to access ovsdb;
# but if we use native access, then we just need python bindings.
# since we don't know what users actually use, we depend on both.
Requires:       ipset
Requires:       iptables
Requires:       openvswitch
Requires:       python-openvswitch
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod


%description openvswitch
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains the Neutron plugin that implements virtual
networks using Open vSwitch.


%package metering-agent
Summary:        Neutron bandwidth metering agent
Requires:       iptables
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description metering-agent
Neutron provides an API to measure bandwidth utilization

This package contains the Neutron agent responsible for generating bandwidth
utilization notifications.


%package rpc-server
Summary:        Neutron (RPC only) Server
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description rpc-server
Neutron provides an API to dynamically request and configure virtual
networks.

This package contains an alternative Neutron server that handles AMQP RPC
workload only.


%package sriov-nic-agent
Summary:        Neutron SR-IOV NIC agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description sriov-nic-agent
Neutron allows to run virtual instances using SR-IOV NIC hardware

This package contains the Neutron agent to support advanced features of
SR-IOV network cards.


%prep
%autosetup -n %{service}-%{upstream_version} -S git

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Let's handle dependencies ourseleves
rm -f requirements.txt

# Kill egg-info in order to generate new SOURCES.txt
rm -rf neutron.egg-info


%build
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build
# Generate i18n files
%{__python2} setup.py compile_catalog -d build/lib/%{service}/locale

# Generate configuration files
PYTHONPATH=. tools/generate_config_file_samples.sh
find etc -name *.sample | while read filename
do
    filedir=$(dirname $filename)
    file=$(basename $filename .sample)
    mv ${filename} ${filedir}/${file}
done

# Loop through values in neutron-dist.conf and make sure that the values
# are substituted into the neutron.conf as comments. Some of these values
# will have been uncommented as a way of upstream setting defaults outside
# of the code. For notification_driver, there are commented examples
# above uncommented settings, so this specifically skips those comments
# and instead comments out the actual settings and substitutes the
# correct default values.
while read name eq value; do
  test "$name" && test "$value" || continue
  if [ "$name" = "notification_driver" ]; then
    sed -ri "0,/^$name *=/{s!^$name *=.*!# $name = $value!}" etc/%{service}.conf
  else
    sed -ri "0,/^(#)? *$name *=/{s!^(#)? *$name *=.*!# $name = $value!}" etc/%{service}.conf
  fi
done < %{SOURCE30}

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Remove unused files
rm -rf %{buildroot}%{python2_sitelib}/bin
rm -rf %{buildroot}%{python2_sitelib}/doc
rm -rf %{buildroot}%{python2_sitelib}/tools

# Move rootwrap files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}/rootwrap
mv %{buildroot}/usr/etc/%{service}/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{service}/rootwrap

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}/usr/etc/%{service}/* %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini %{buildroot}%{_datadir}/%{service}/api-paste.ini

# The generated config files are not moved automatically by setup.py
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2

mv etc/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf
for agent in dhcp l3 metadata metering
do
  mv etc/${agent}_agent.ini %{buildroot}%{_sysconfdir}/%{service}/${agent}_agent.ini
done
for file in linuxbridge_agent ml2_conf ml2_conf_sriov openvswitch_agent sriov_agent
do
  mv etc/%{service}/plugins/ml2/${file}.ini %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2/${file}.ini
done

# Install logrotate
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install sudoers
install -p -D -m 440 %{SOURCE2} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install systemd units
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/neutron-server.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/neutron-linuxbridge-agent.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/neutron-openvswitch-agent.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/neutron-dhcp-agent.service
install -p -D -m 644 %{SOURCE16} %{buildroot}%{_unitdir}/neutron-l3-agent.service
install -p -D -m 644 %{SOURCE17} %{buildroot}%{_unitdir}/neutron-metadata-agent.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/neutron-ovs-cleanup.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/neutron-macvtap-agent.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/neutron-metering-agent.service
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_unitdir}/neutron-sriov-nic-agent.service
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_unitdir}/neutron-netns-cleanup.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/neutron-rpc-server.service
install -p -D -m 644 %{SOURCE32} %{buildroot}%{_unitdir}/neutron-linuxbridge-cleanup.service

# Install helper scripts
install -p -D -m 755 %{SOURCE33} %{buildroot}%{_bindir}/neutron-enable-bridge-firewall.sh

# Install scripts for pacemaker support
install -p -D -m 755 %{SOURCE23} %{buildroot}%{_prefix}/lib/ocf/lib/neutron/neutron-netns-cleanup
install -p -D -m 755 %{SOURCE24} %{buildroot}%{_prefix}/lib/ocf/lib/neutron/neutron-ovs-cleanup
install -p -D -m 755 %{SOURCE25} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/NetnsCleanup
install -p -D -m 755 %{SOURCE26} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/OVSCleanup
install -p -D -m 755 %{SOURCE27} %{buildroot}%{_prefix}/lib/ocf/resource.d/neutron/NeutronScale

# Install sysctl and modprobe config files to enable bridge firewalling
# NOTE(ihrachys) we effectively duplicate same settings for each affected l2
# agent. This can be revisited later.
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-openvswitch-agent.conf
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-linuxbridge-agent.conf
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules

# Install README file that describes how to configure services with custom configuration files
install -p -D -m 755 %{SOURCE31} %{buildroot}%{_sysconfdir}/%{service}/conf.d/README

# Setup directories
install -d -m 755 %{buildroot}%{_datadir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

# Install dist conf
install -p -D -m 640 %{SOURCE30} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf

# Create and populate configuration directory for L3 agent that is not accessible for user modification
mkdir -p %{buildroot}%{_datadir}/%{service}/l3_agent
ln -s %{_sysconfdir}/%{service}/l3_agent.ini %{buildroot}%{_datadir}/%{service}/l3_agent/l3_agent.conf

# Create dist configuration directory for neutron-server (may be filled by advanced services)
mkdir -p %{buildroot}%{_datadir}/%{service}/server

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/common
for service in server rpc-server ovs-cleanup netns-cleanup linuxbridge-cleanup macvtap-agent; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service
done
for service in linuxbridge openvswitch dhcp l3 metadata metering sriov-nic; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service-agent
done

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python2_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang %{service} --all-name

%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
getent passwd %{service} >/dev/null || \
    useradd -r -g %{service} -d %{_sharedstatedir}/%{service} -s /sbin/nologin \
    -c "OpenStack Neutron Daemons" %{service}
exit 0


%post
%systemd_post neutron-dhcp-agent.service
%systemd_post neutron-l3-agent.service
%systemd_post neutron-metadata-agent.service
%systemd_post neutron-server.service
%systemd_post neutron-netns-cleanup.service
%systemd_post neutron-ovs-cleanup.service
%systemd_post neutron-linuxbridge-cleanup.service


%preun
%systemd_preun neutron-dhcp-agent.service
%systemd_preun neutron-l3-agent.service
%systemd_preun neutron-metadata-agent.service
%systemd_preun neutron-server.service
%systemd_preun neutron-netns-cleanup.service
%systemd_preun neutron-ovs-cleanup.service
%systemd_preun neutron-linuxbridge-cleanup.service


%postun
%systemd_postun_with_restart neutron-dhcp-agent.service
%systemd_postun_with_restart neutron-l3-agent.service
%systemd_postun_with_restart neutron-metadata-agent.service
%systemd_postun_with_restart neutron-server.service
%cleanup_orphan_rootwrap_daemons


%post macvtap-agent
%systemd_post neutron-macvtap-agent.service


%preun macvtap-agent
%systemd_preun neutron-macvtap-agent.service


%postun macvtap-agent
%systemd_postun_with_restart neutron-macvtap-agent.service


%post linuxbridge
%systemd_post neutron-linuxbridge-agent.service
oldconf=%{_sysconfdir}/%{service}/plugins/linuxbridge/linuxbridge_conf.ini
newconf=%{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
if [ $1 -gt 1 ]; then
    if [ -e $oldconf ]; then
        # Imitate noreplace
        cp $newconf ${newconf}.rpmnew
        cp $oldconf $newconf
    fi
fi


%preun linuxbridge
%systemd_preun neutron-linuxbridge-agent.service


%postun linuxbridge
%systemd_postun_with_restart neutron-linuxbridge-agent.service


%post openvswitch
%systemd_post neutron-openvswitch-agent.service
oldconf=%{_sysconfdir}/%{service}/plugins/openvswitch/ovs_neutron_plugin.ini
newconf=%{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
if [ $1 -gt 1 ]; then
    if [ -e $oldconf ]; then
        # Imitate noreplace
        cp $newconf ${newconf}.rpmnew
        cp $oldconf $newconf
    fi
fi

if [ $1 -ge 2 ]; then
    # We're upgrading

    # Detect if the neutron-openvswitch-agent is running
    ovs_agent_running=0
    systemctl status neutron-openvswitch-agent > /dev/null 2>&1 && ovs_agent_running=1 || :

    # If agent is running, stop it
    [ $ovs_agent_running -eq 1 ] && systemctl stop neutron-openvswitch-agent > /dev/null 2>&1 || :

    # Search all orphaned neutron-rootwrap-daemon processes and since all are triggered by sudo,
    # get the actual rootwrap-daemon process.
    %cleanup_orphan_rootwrap_daemons

    # If agent was running, start it back with new code
    [ $ovs_agent_running -eq 1 ] && systemctl start neutron-openvswitch-agent > /dev/null 2>&1 || :
fi


%preun openvswitch
%systemd_preun neutron-openvswitch-agent.service


%postun openvswitch
%systemd_postun_with_restart neutron-openvswitch-agent.service


%post metering-agent
%systemd_post neutron-metering-agent.service


%preun metering-agent
%systemd_preun neutron-metering-agent.service


%postun metering-agent
%systemd_postun_with_restart neutron-metering-agent.service


%post sriov-nic-agent
%systemd_post neutron-sriov-nic-agent.service


%preun sriov-nic-agent
%systemd_preun neutron-sriov-nic-agent.service


%postun sriov-nic-agent
%systemd_postun_with_restart neutron-sriov-nic-agent.service


%files
%license LICENSE
%{_bindir}/neutron-db-manage
%{_bindir}/neutron-debug
%{_bindir}/neutron-dhcp-agent
%{_bindir}/neutron-ipset-cleanup
%{_bindir}/neutron-keepalived-state-change
%{_bindir}/neutron-l3-agent
%{_bindir}/neutron-linuxbridge-cleanup
%{_bindir}/neutron-metadata-agent
%{_bindir}/neutron-netns-cleanup
%{_bindir}/neutron-ovs-cleanup
%{_bindir}/neutron-pd-notify
%{_bindir}/neutron-sanity-check
%{_bindir}/neutron-server
%{_bindir}/neutron-usage-audit
%{_prefix}/lib/ocf/lib/neutron/neutron-netns-cleanup
%{_prefix}/lib/ocf/lib/neutron/neutron-ovs-cleanup
%{_prefix}/lib/ocf/resource.d/neutron/NetnsCleanup
%{_prefix}/lib/ocf/resource.d/neutron/OVSCleanup
%{_prefix}/lib/ocf/resource.d/neutron/NeutronScale
%{_unitdir}/neutron-dhcp-agent.service
%{_unitdir}/neutron-l3-agent.service
%{_unitdir}/neutron-metadata-agent.service
%{_unitdir}/neutron-server.service
%{_unitdir}/neutron-netns-cleanup.service
%{_unitdir}/neutron-ovs-cleanup.service
%{_unitdir}/neutron-linuxbridge-cleanup.service
%attr(-, root, %{service}) %{_datadir}/%{service}/api-paste.ini
%dir %{_datadir}/%{service}/l3_agent
%dir %{_datadir}/%{service}/server
%{_datadir}/%{service}/l3_agent/*.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/dhcp_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/l3_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metadata_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/policy.json
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-dhcp-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-l3-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metadata-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-server
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-netns-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-ovs-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-cleanup


%files -n python-%{service}-tests
%license LICENSE
%{python2_sitelib}/%{service}/tests


%files -n python-%{service}
%license LICENSE
%{python2_sitelib}/%{service}
%{python2_sitelib}/%{service}-*.egg-info
%exclude %{python2_sitelib}/%{service}/tests


%files common -f %{service}.lang
%license LICENSE
%doc README.rst
# though this script is not exactly needed on all nodes but for ovs and
# linuxbridge agents only, it's probably good enough to put it here
%{_bindir}/neutron-enable-bridge-firewall.sh
%{_bindir}/neutron-rootwrap
%{_bindir}/neutron-rootwrap-daemon
%{_bindir}/neutron-rootwrap-xen-dom0
%dir %{_sysconfdir}/%{service}
%{_sysconfdir}/%{service}/conf.d/README
%dir %{_sysconfdir}/%{service}/conf.d
%dir %{_sysconfdir}/%{service}/conf.d/common
%dir %{_sysconfdir}/%{service}/plugins
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%{_sysconfdir}/sudoers.d/%{service}
%dir %attr(0755, %{service}, %{service}) %{_sharedstatedir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/log/%{service}
%dir %{_datarootdir}/%{service}
%dir %{_datarootdir}/%{service}/rootwrap
%{_datarootdir}/%{service}/rootwrap/debug.filters
%{_datarootdir}/%{service}/rootwrap/dhcp.filters
%{_datarootdir}/%{service}/rootwrap/dibbler.filters
%{_datarootdir}/%{service}/rootwrap/ebtables.filters
%{_datarootdir}/%{service}/rootwrap/ipset-firewall.filters
%{_datarootdir}/%{service}/rootwrap/iptables-firewall.filters
%{_datarootdir}/%{service}/rootwrap/l3.filters
%{_datarootdir}/%{service}/rootwrap/netns-cleanup.filters


%files linuxbridge
%license LICENSE
%{_bindir}/neutron-linuxbridge-agent
%{_unitdir}/neutron-linuxbridge-agent.service
%{_datarootdir}/%{service}/rootwrap/linuxbridge-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-agent
%{_sysctldir}/99-neutron-linuxbridge-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules


%files macvtap-agent
%license LICENSE
%{_bindir}/neutron-macvtap-agent
%{_unitdir}/neutron-macvtap-agent.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-macvtap-agent


%files ml2
%license LICENSE
%doc %{service}/plugins/ml2/README
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/*.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini


%files openvswitch
%license LICENSE
%{_bindir}/neutron-openvswitch-agent
%{_unitdir}/neutron-openvswitch-agent.service
%{_datarootdir}/%{service}/rootwrap/openvswitch-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-openvswitch-agent
%{_sysctldir}/99-neutron-openvswitch-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules


%files metering-agent
%license LICENSE
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metering_agent.ini
%{_unitdir}/neutron-metering-agent.service
%{_bindir}/neutron-metering-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metering-agent


%files rpc-server
%license LICENSE
%{_bindir}/neutron-rpc-server
%{_unitdir}/neutron-rpc-server.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-rpc-server


%files sriov-nic-agent
%license LICENSE
%{_unitdir}/neutron-sriov-nic-agent.service
%{_bindir}/neutron-sriov-nic-agent
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/sriov_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-sriov-nic-agent


%changelog
* Wed Sep 08 2021 Miguel Garcia <mgarciac@redhat.com> 1:9.4.1-56
- Update patches

* Wed Sep 08 2021 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-55
- Remove dhcp_extra_opt value after first newline character (rhbz#2000785)

* Mon Nov 25 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:9.4.1-53
- Use threading for pinging the floating IP (rhbz#1738695)
- Fixes overwrite of pre-existing other_config (rhbz#1635075)

* Fri Nov 15 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-52
- Switch to use cast method in dhcp_ready_on_ports method (rhbz#1774764)
- Limit max ports per rpc for dhcp_ready_on_ports() (rhbz#1774764)

* Tue Oct 29 2019 Brian Haley <bhaley@redhat.com> 1:9.4.1-51
- Reduce timeout and number of arping attempts (rhbz#1738695)

* Tue Oct 22 2019 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:9.4.1-50
- Delay floating IP assignation in DVR router during migration (rhbz#1738695)

* Wed Sep 25 2019 Jakub Libosvar <libosvar@redhat.com> 1:9.4.1-49
- Reduce IP address collision during port creating (rhbz#1752374)

* Fri Aug 02 2019 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:9.4.1-48
- Change VF status from "enable" to "auto". (rhbz#1735676)

* Tue Jul 09 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-47
- DVR: FIP gateway port is tagged as DEAD port by OVS with external-bridge (rhbz#1727955)

* Fri Jul 05 2019 Nate Johnston <nate.johnston@redhat.com> 1:9.4.1-46
- Do not release DHCP lease when no client ID is set on port (rhbz#1723116)

* Fri Jun 21 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-45
- dvr: Don't raise KeyError in _get_floatingips_bound_to_host (rhbz#1715784)

* Sat May 18 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-44
- Enable 'all' IPv6 forwarding knob correctly (rhbz#1707939)

* Sat May 18 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-43
- Fix handling of network:shared field in policy module (rhbz#1712271)
- Fix creating policy rules from subattributes. (rhbz#1712271)
- Add missing policy actions to policy.json file (rhbz#1712271)

* Thu Mar 28 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-42
- Choose random value for HA routes' vr_id (rhbz#1578459)

* Thu Mar 28 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-41
- Add permanent ARP entries for DVR fip/qrouter veth pair (rhbz#1692772)
- Fix callers of get_devices_with_ip() to pass addresses (rhbz#1692772)

* Wed Mar 27 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:9.4.1-40
- When converting sg rules to iptables, do not emit dport if not supported (rhbz#1690387)

* Tue Mar 19 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-39
- Do not raise an error deleting neighbour entry (rhbz#1692772)

* Mon Mar 18 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-38
- Enable ipv6_forwarding in HA router's namespace (rhbz#1684533)

* Mon Mar 18 2019 Brian Haley <bhaley@redhat.com> 1:9.4.1-37
- Run revision bump operations en masse (rhbz#1665239)
- DVR: Multiple csnat ports created when RouterPort table update fails (rhbz#1637463)
- Wait to ipv6 forwarding be really changed by L3 agent (rhbz#1684533)
- Skip IPv6 sysctl calls when IPv6 is disabled (rhbz#1685272)

* Fri Mar 15 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-36
- Fix update of ports cache in router_info class (rhbz#1666666)

* Fri Mar 15 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-35
- Fix notification about arp entries for dvr routers (rhbz#1671653)

* Mon Jan 07 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-34
- Fix connectivity via 2 routers test (rhbz#1603203)
- Add connectivity test via 2 routers and tenant networks (rhbz#1603203)
- Do not delete trunk bridges if service port attached (rhbz#1656398)

* Mon Jan 07 2019 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-33
- DVR: Server side patch to schedule an unbound port with Floating IP (rhbz#1658903)

* Sat Nov 03 2018 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-32
- Fix connection between 2 dvr routers (rhbz#1603203)

* Fri Nov 02 2018 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-31
- Fix corner case in failure assigning MAC to SR-IOV NIC (rhbz#1608584)
- Reduce rpc calls in SR-IOV agent (rhbz#1643761)
- Revert "DVR: Inter Tenant Traffic between networks not possible with shared net" (rhbz#1600180)

* Mon Sep 17 2018 Bernard Cafarelli <bcafarel@redhat.com> 1:9.4.1-30
- ovsdb monitor: do not die on ovsdb-client stderr output (rhbz#1629629)

* Fri Aug 31 2018 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-29
- Remove fdb entries for ha router interfaces when going DOWN (rhbz#1622497)

* Thu Jul 26 2018 Assaf Muller <amuller@redhat.com> 1:9.4.1-28
- Disallow router interface out of subnet IP range (rhbz#1608087)

* Wed Jul 18 2018 Brian Haley <bhaley@redhat.com> 1:9.4.1-27
- DVR: Inter Tenant Traffic between networks not possible with shared net (rhbz#1600180)

* Tue Jun 19 2018 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-26
- [OVS] Add mac-table-size to be set on each ovs bridge (rhbz#1589031)

* Tue Jun 05 2018 Brian Haley <bhaley@redhat.com> 1:9.4.1-25
- Disable IPv6 forwarding by default on HA routers (rhbz#1584845)

* Wed May 30 2018 Brian Haley <bhaley@redhat.com> 1:9.4.1-24
- Retry dhcp_release on failures (rhbz#1578414)

* Tue May 22 2018 Jakub Libosvar <libosvar@redhat.com> 1:9.4.1-23
- Override ovsdb_timeout default value in ovs_cleanup tool (rhbz#1532280)
- Improve DbListCommand operation from O(n^2) to O(n) (rhbz#1575696)
- Avoid agents adding ports as trunk by default. (rhbz#1575706)
- Don't delete flows on ports which were on dead vlan during plug (rhbz#1575706 rhbz#1579400)

* Fri May 11 2018 Sławek Kapłoński <slawek@kaplonski.pl> 1:9.4.1-22
- Monitor phys_bridges to reconfigured it if created again (rhbz#1576256)
- Adding fix to failing scenario tests in CI (rhbz#1575356)

* Fri May 04 2018 Sławek Kapłoński <slawek@kaplonski.pl> 1:9.4.1-21
- Fix parallel deletion of subnets. (rhbz#1511394)

* Fri Apr 27 2018 Slawek Kaplonski <skaplons@redhat.com> 1:9.4.1-20
- ml2: fix update_device_up to send lm events with linux bridge (rhbz#1565503)
- [RBAC] Fix setting network as not shared (rhbz#1570908)

* Fri Apr 27 2018 Saravanan KR <skramaja@redhat.com> 1:9.4.1-19
- adds support for vhost user reconnect. (rhbz#1557850)

* Wed Apr 25 2018 Bernard Cafarelli <bcafarel@redhat.com> 1:9.4.1-18
- Require dnsmasq version >= 2.76 (rhbz#1545006)

* Tue Apr 24 2018 Bernard Cafarelli <bcafarel@redhat.com> 1:9.4.1-17
- Write vrrp_script before (re)starting keepalived (rhbz#1567493)
- tempest: Use kwargs for create_server (rhbz#1561907)
- Add a tempest scenario for floating-ip (rhbz#1561907)
- Checking functionality of DVR (rhbz#1561907)
- Using a new security group in scenario tests (rhbz#1561907)

* Thu Mar 22 2018 Brian Haley <bhaley@redhat.com> 1:9.4.1-16
- Remove race and simplify conntrack state management (rhbz#1532273)
- Process conntrack updates in worker threads (rhbz#1532273)
- DVR: verify subnet has gateway_ip before installing IPv4 flow (rhbz#1539549)

* Mon Mar 12 2018 Daniel Alvarez <dalvarez@redhat.com> 1:9.4.1-15
- Spawn/stop metadata proxies upon adding/deleting router interfaces (rhbz#1540452)
- More efficiently clean up OVS ports (rhbz#1532280)

* Thu Feb 08 2018 Terry Wilson <twilson@redhat.com> 1:9.4.1-14
- Improve neutron-ovs-cleanup performance (rhbz#1532280)

* Mon Feb 05 2018 Assaf Muller <amuller@redhat.com> 1:9.4.1-13
- Pass parameters when create eventlet.wsgi server (rhbz#1541242)

* Thu Jan 18 2018 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.4.1-12
- l3_ha: only pass host into update_port when updating router port bindings (rhbz#1535620)

* Wed Jan 10 2018 Jakub Libosvar <libosvar@redhat.com> 1:9.4.1-11
- ovs-lib: Pass string as udp port to ovsdb (rhbz#1533653)
- functional-tests: Make addresses for tunneling unique (rhbz#1533653)
- Call update_all_ha_network_port_statuses on agent start

* Thu Jan 04 2018 Terry Wilson <twilson@redhat.com> 1:9.4.1-10
- Remove timeout for neutron-ovs-cleanup stop/start (rhbz#1531144)

* Thu Nov 16 2017 venkata anil <anilvenkata@redhat.com> 1:9.4.1-9
- Don't wait on TRY_AGAIN when calling commit_block() (rhbz#1512274)

* Tue Nov 14 2017 Brian Haley <bhaley@redhat.com> 1:9.4.1-8
- Move check_ha_state_for_router() into notification code (rhbz#1505005)

* Tue Nov 14 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.4.1-7
- Tempest: Fixing L3 agent hosting router for DVR setup (rhbz#1436579)

* Wed Nov 08 2017 Brian Haley <bhaley@redhat.com> 1:9.4.1-6
- Fix bad l3-agent backport to stable/newton (rhbz#1510157)
- Change OVS agent to update skipped port status to DOWN (rhbz#1481620)
- Skip setup_port_filters for skipped_devices (rhbz#1481620)

* Wed Oct 25 2017 Jason Joyce <jjoyce@redhat.com> 1:9.4.1-5
- rally: switch to new format for context name
- Fix missing super's skip_checks()
- test_ha_router: wait until two agents are scheduled
- DHCP provisioning block only on port addr update
- Match load_rc_for_rally logic to load_rc_hook
- Prioritize tox environment executables for fullstack/functional tests
- Linuxbridge agent: detect existing IP on bridge
- Fixes import_modules_recursively for Windows
- Stop logging versions on every agent update
- Enforce ethertype with IPv6 integer protocols
- Reduce rally sub-port count
- Trim rally scenario sizes

* Tue Oct 24 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.4.1-4
- iptables: don't log lock error if we haven't passed -w (rhbz#1504791)
- Notify port_update to agent for status change (rhbz#1502572)

* Mon Oct 09 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.4.1-3
- Tempest: Adopt keystone api v3 for tests (rhbz#1493068)

* Mon Sep 18 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.4.1-2
- Make use of -w argument for iptables calls (rhbz#1489070)

* Fri Sep 01 2017 Steve Linabery <slinaber@redhat.com> 1:9.4.1-1
- Update to 9.4.1

* Tue Aug 29 2017 venkata anil <anilvenkata@redhat.com> 1:9.4.0-3
- Fix test_keepalived_ipv6_support for Keepalived v1.2.20, rhbz#1484281
- Functional tests: change assert to wait_until_true

* Fri Aug 11 2017 Steve Linabery <slinaber@redhat.com> 1:9.4.0-2
- Revert "deepcopy binding and binding levels avoid expiration"
- QoS: update the database before notifying the backend on delete
- Always call create_rtr_2_fip_link
- Drop IPv6 Router Advertisements in OVS firewall
- Fix tempest test failing with segments extension
- Use subqueryload in l2pop DB for binding ports
- [Pecan] Fix custom tenant_id project_id matching
- tempest: Make _create_router_with_client obey enable_snat=False
- tempest: Obey identity_feature_enabled.api_v2_admin in a few tests
- Correctly configure IPv6 addresses on upgrades
- neutron-rpc-server fails with no plugins loaded
- Ignore gre devices in namespaces when cleaning up devices
- Use e.exc_type instead of calling str on exception
- Fix tempest router migration test when HA enabled, v2
- Stop arping when interface gets deleted
- Add missing unit test for segment db
- Don't iterate updated_rule_sg_ids or updated_sg_members
- Update minimum tox version to 2.3.2
- test_dhcp: Use a safer host name
- Retry ebtables lock acquisition failures
- Mask password when logging request body
- Macvtap: Check for no original port in is_live_migration
- deepcopy binding and binding levels avoid expiration
- Update pylint disable list to pass pylint 1.7.1 checks
- l3_ha_mode: call bulk _populate_mtu_and_subnets_for_ports
- api: work around Routes cutting off suffix from resource id
- Add API test for tag
- ovs: bubble up failures into main thread in native ofctl mode

* Thu Aug 10 2017 Steve Linabery <slinaber@redhat.com> 1:9.4.0-1
- Update to 9.4.0

* Mon Jul 24 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.3.1-10
- Enable bridge firewalling on platform level, rhbz#1474119

* Mon Jul 24 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.3.1-9
- Fix: set IPv6 forwarding when there's an IPv6 gw (rhbz#1426735)
- Disable RA and IPv6 forwarding on backup HA routers
- Add IPv6 default route to DHCP namespace
- Disable 'accept_ra' in DHCP agent namespace

* Mon Jul 24 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.3.1-8
- Switch ns-metadata-proxy to haproxy (rhbz#1438469)

* Mon Jul 24 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.3.1-7
- Set HA network port to DOWN when l3 agent starts (rhbz#1461111)

* Mon Jul 24 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.3.1-6
- Update the host_id for network:router_gateway interfaces (rhbz#1466081)

* Mon Jul 24 2017 Assaf Muller <amuller@redhat.com> 1:9.3.1-5
- Use _is_dns_integration_supported for _delete_floatingip (rhbz#1468314)

* Mon Jul 24 2017 Venkata Anil Kommaddi <vkommadi@redhat.com> 1:9.3.1-4
- Avoid router ri.process if initialize() fails (rhbz#1437820)

* Mon Jul 24 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.3.1-3
- Send both gratuitous ARP REQUESTs and REPLYs (rhbz#1390863)

* Mon Jul 24 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.3.1-2.1
- Enable bridge firewalling on platform level, rhbz#1474119

* Tue May 23 2017 Jason Joyce <jjoyce@redhat.com> 1:9.3.1-2
- Removing require on python-webtest >= 2.0 (rhbz#1454448)

* Mon May 22 2017 Jason Joyce <jjoyce@redhat.com> 1:9.3.1-1
- Update to 9.3.1
- Switch RootHelperProcess from select.poll to select.select
- Handle auto-address subnets on port update
- Remove stale floating IP addresses from rfp devices
- Clean up ovsdb-native's use of verify()
- Set OVS inactivity_probe to vsctl_timeout when adding manager
- Add support for Keepalived VRRP health check
- Assert contents of returned devices in test
- Print useful error on rootwrap daemon failure
- Ignore gre devices when fetching devices in
- Allow self-sharing RBAC rules to be deleted without usage
- Ensure behavior of None for device_id
- Dont try to apply iptables rules in a endless loop
- Lock in DHCP agent based on network_id
- fullstack: Compile openvswitch module for fullstack test
- Pass --concurrent flag to ebtables calls
- Simplify RootHelperProcess._read_stream()
- DVR: Don't clean snat-ns of DVR HA router when fullsync

* Thu May 18 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.2.0-13
- Wait 2 seconds between gratuitous ARP updates instead of 1 second (rhbz#1390863)
- Get rid of delete_subnet method in ML2 (rhbz#1436068)
- Fix tempest router timestamp test when HA enabled (rhbz#1433671)

* Mon May 15 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.2.0-12
- Clean up orphaned rootwrap daemon processes on update, rhbz#1450223

* Thu Apr 13 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.2.0-11
- Revert "Fix DetachedInstanceError on subnet delete" (rhbz#1440901)

* Fri Apr 07 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.2.0-10
- Fix tabs/spaces issue with setup.cfg, rhbz#1440099

* Thu Apr 06 2017 Jakub Libosvar <jlibosva@redhat.com> - 1:9.2.0-9
- Set TimeoutStartSec to 0, rhbz#1439246

* Thu Mar 30 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.2.0-8
- Fix Quota error while running tests, rhbz#1433698

* Tue Mar 28 2017 Ihar Hrachyshka <ihrachys@redhat.com> 1:9.2.0-7
- Throttle SIGHUPs to keepalived, rhbz#1436359
- Fix DetachedInstanceError on subnet delete, rhbz#1436068

* Mon Mar 20 2017 Jakub Libosvar <libosvar@redhat.com> 1:9.2.0-6.el7
- Fixes DBDeadlock race condition during driver initialization. (rhbz#1426726)

* Thu Mar 16 2017 Jakub Libosvar <libosvar@redhat.com> 1:9.2.0-5.el7
- Allow the other nic to allocate VMs post PCI-PT VM creation. (rhbz#1369768)

* Thu Mar 09 2017 Jon Schlueter <jschluet@redhat.com> 1:9.2.0-4
- rebase to stable/newton (rhbz#1430712)
- Allow no network to be passed into PortContext
- Avoid segment DB lookup in _expand_segment on port
- Switch to use test_utils.call_until_true
- Bulk creation of SecurityGroups
- Do not try and remove non-existent iptables chains
- Invert device_owner to avoid filtering too much
- DVR: delete stale devices after router update
- DVR: Add static routes to FIP namespace
- Imported Translations from Zanata
- Display deprecation warning in test only once
- tempest: Fix qos extension check
- Disallow specifying too long name and description for qos

* Tue Mar 07 2017 Jakub Libosvar <libosvar@redhat.com> 1:9.2.0-3.el7
- Skip native DHCP notifications on status change

* Mon Feb 13 2017 Jon Schlueter <jschluet@redhat.com> 1:9.2.0-2
- Manually add pk for alembic_version table (lp#1655610)
- DVR: Fix IPtables driver for metering with DVR routers (lp#1506567)
- Change the order of installing flows for br-int (lp#1642223)
- Raise AssertionError instead of eventlet.timeout.Timeout when failing (lp#1654283)
- Tempest tests uses only supported QoS rule types (lp#1644097)

* Mon Feb 13 2017 Jon Schlueter <jschluet@redhat.com> 1:9.2.0-1
- Update to 9.2.0 (rhbz#1421806)

* Mon Feb 13 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.1.1-8
- Kill the metadata proxy process unconditionally, rhbz#1416265

* Fri Feb 03 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.1.1-7
- Revert "Setup firewall filters only for required ports", rhbz#1406263

* Fri Jan 20 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.1.1-6
- Kill neutron-keepalived-state-change gracefully, rhbz#1397418

* Thu Jan 19 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.1.1-5
- Fix a bug in process_spawn binding on ports, rhbz#1397418

* Thu Jan 19 2017 Daniel Alvarez <dalvarez@redhat.com> 1:9.1.1-4
- Kill processes when cleaning up namespaces, rhbz#1397418

* Wed Jan 18 2017 Jakub Libosvar <jlibosva@redhat.com> - 1:9.1.1-3
- Fix setup.cfg for backported patches, rhbz#1397418

* Fri Jan 06 2017 Jon Schlueter <jschluet@redhat.com> 1:9.1.1-2
- Fix DHCP Port Creation on Service Subnets (lp#1636963)
- Correctly print --limit value passed via API (lp#1649665)
- Use subqueries for rbac_entries and subnets<->network (lp#1649317)
- Delete conntrack when remote ipset member removed (lp#1580377)
- Add a trunk rally test
- Add rally hook to neutron devstack plugin
- Imported Translations from Zanata
- Skip larger than /64 subnets in DHCP agent (lp#1645616)
- SRIOV: don't block report_state with device count (lp#1648206)
- Speed-up iptables_manager remove_chain() code (lp#1642770)
- Only send string values to OVSDB other_config column (lp#1630920)
- Don't compile OVS kernel modules for functional job (lp#1646107)
- ovs-agent: Close ryu app on all exceptions (lp#1611237)
- callbacks: Make the value of FLOATING_IP match with api resource (lp#1642918)
- Changing arping command execute to accept 1 as extra OK code (lp#1578842)
- ovs-agent: Catch exceptions in agent_main_wrapper (lp#1611237)
- ovsdb: don't erase existing ovsdb managers (rhbz#1394865)

* Fri Jan 06 2017 Jon Schlueter <jschluet@redhat.com> 1:9.1.1-1
- Update to 9.1.1

* Thu Dec 01 2016 John Schwarz <jschwarz@redhat.com> 1:9.1.0-8
- Migrate device_owner for router's interface, rhbz#1399742

* Mon Nov 28 2016 Jason Joyce <jjoyce@redhat.com> 1:9.1.0-7
- DVR: remove misleading error log
- iptables: fail to start ovs/linuxbridge agents on missing sysctl knobs
- Fixed functional iptables firewall tests for newer kernels
- Allow to override Idl class in OVSDB Connection
- l3-ha: Send gratuitous ARP when new floating IP is added

* Mon Nov 21 2016 Jason Joyce <jjoyce@redhat.com> 1:9.1.0-6
- Install OVS from git if current version < 2.5.1
- Add L3 HA test with linux bridge
- Fix "failed unplugging ha interface" error when deleting router

* Thu Nov 17 2016 Jason Joyce <jjoyce@redhat.com> 1:9.1.0-5
- Truncate IPDevice's name to interface max size
- Parse the output of ip route more robustly
- Reduce rally executions of create_and_list_ports
- Lower concurrency on rally port job
- Only mark ports ready on synced networks
- DHCP: Add missing path for marking ports as ready
- Add unit tests for ip_lib.get_routing_table

* Mon Nov 14 2016 Jon Schlueter <jschluet@redhat.com> 1:9.1.0-4
- Update metadata proxy when subnet add/delete

* Sun Nov 13 2016 Nir Magnezi <nmagnezi@redhat.com> 1:9.1.0-3
- l3-ha: Send gratuitous ARP when new floating IP is added, rhbz#1386718

* Tue Nov 08 2016 Jon Schlueter <jschluet@redhat.com> 1:9.1.0-2
- Check if namespace exists before getting devices

* Mon Nov 07 2016 Jon Schlueter <jschluet@redhat.com> 1:9.1.0-1
- Update to 9.1.0

* Mon Nov 07 2016 John Schwarz <jschwarz@redhat.com> 1:9.0.0-1.7
- Add http_proxy_to_wsgi to api-paste, rhbz#1384334

* Mon Nov 07 2016 John Schwarz <jschwarz@redhat.com> 1:9.0.0-1.6
- Don't depend on translated strings for error check, rhbz#1387546

* Mon Oct 24 2016 Jon Schlueter <jschluet@redhat.com> 1:9.0.0-1.5
- ovsfw: Add a dl_type match for action=ct flows

* Thu Oct 20 2016 Jon Schlueter <jschluet@redhat.com> 1:9.0.0-1.4
- Extend project_id in object dicts (Newton only)
- Add required extension to trunk_details descriptor
- Fix misleading error trace in trunk fullstack life cycle test

* Fri Oct 14 2016 Jon Schlueter <jschluet@redhat.com> 1:9.0.0-1.3
- relaxing Requires for python-neutron-tests on python-webtest >= 2.0

* Fri Oct 14 2016 Jon Schlueter <jschluet@redhat.com> 1:9.0.0-1.2
- L3 DVR: always notify on ROUTER_INTERFACE AFTER_CREATE
- Fix the 'port_id' attribute not exist error
- TestSanityCheck: drop test tables during cleanup
- New option for num_threads for state change server

* Tue Oct 11 2016 Jakub Libosvar <libosvar@redhat.com> - 1:9.0.0-1.1
- Ignore gre0 and gretap0 devices in netns cleanup script, rhbz#1382717

* Thu Oct 06 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:9.0.0-1
- Update to 9.0.0

* Thu Sep 29 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:9.0.0-0.4.0rc3
- Update to 9.0.0.0rc3

* Thu Sep 29 2016 Alan Pevec <alan.pevec@redhat.com> 1:9.0.0-0.3.0rc2
- Update to 9.0.0.0rc2

* Wed Sep 21 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:9.0.0-0.2.0rc1
- Update to 9.0.0.0rc1

* Wed Sep 14 2016 Haikel Guemar <hguemar@fedoraproject.org> 1:9.0.0-0.1.0b3
- Update to 9.0.0.0b3

